--[[
This is free and unencumbered software released into the public domain.

Anyone is free to copy, modify, publish, use, compile, sell, or
distribute this software, either in source code form or as a compiled
binary, for any purpose, commercial or non-commercial, and by any
means.

See <LICENSE.txt> for the whole license.
For more information, see <http://unlicense.org>.
]]

if not factorioEducationalMod then factorioEducationalMod = {} end

require('utils.utils')


---- Removing military stuff

-- Guns
factorioEducationalMod.removeRecipeAndEntity("combat-shotgun","gun")
factorioEducationalMod.removeRecipeAndEntity("flamethrower","gun")
-- Freeplay scenario try to add a gun, let it in the game while searching for a workaround
--factorioEducationalMod.removeRecipeEntityAndItem("pistol","gun")
factorioEducationalMod.removeRecipeAndEntity("railgun","gun")
factorioEducationalMod.removeRecipeAndEntity("rocket-launcher","gun")
factorioEducationalMod.removeRecipeAndEntity("shotgun","gun")
factorioEducationalMod.removeRecipeAndEntity("submachine-gun","gun")
factorioEducationalMod.removeEntity("tank-cannon","gun")
factorioEducationalMod.removeEntity("tank-flamethrower","gun")
factorioEducationalMod.removeEntity("tank-machine-gun","gun")
factorioEducationalMod.removeEntity("vehicle-machine-gun","gun")
-- Remove guns from car
data.raw.car.car.guns=nil

-- Mines

factorioEducationalMod.removeRecipeEntityAndItem("land-mine","land-mine")

-- Ammunitions

factorioEducationalMod.removeRecipeAndEntity("atomic-bomb","ammo")
factorioEducationalMod.removeRecipeAndEntity("cannon-shell","ammo")
factorioEducationalMod.removeRecipeAndEntity("explosive-cannon-shell","ammo")
factorioEducationalMod.removeRecipeAndEntity("explosive-rocket","ammo")
factorioEducationalMod.removeRecipeAndEntity("explosive-uranium-cannon-shell","ammo")
-- Used by piercing rounds magazine
--factorioEducationalMod.removeRecipeAndEntity("firearm-magazine","ammo")
factorioEducationalMod.removeRecipeAndEntity("flamethrower-ammo","ammo")
-- Still used by military science pack, don't remove for now
--factorioEducationalMod.removeRecipeAndEntity("piercing-rounds-magazine","ammo")
factorioEducationalMod.removeRecipeAndEntity("piercing-shotgun-shell","ammo")
factorioEducationalMod.removeRecipeAndEntity("railgun-dart","ammo")
factorioEducationalMod.removeRecipeAndEntity("rocket","ammo")
factorioEducationalMod.removeRecipeAndEntity("shotgun-shell","ammo")
factorioEducationalMod.removeRecipeAndEntity("uranium-cannon-shell","ammo")
factorioEducationalMod.removeRecipeAndEntity("uranium-rounds-magazine","ammo")

-- Capsules (include grenades and remote for discharge defense)

factorioEducationalMod.removeRecipeAndEntity("cluster-grenade","capsule")
factorioEducationalMod.removeRecipeAndEntity("defender-capsule","capsule")
factorioEducationalMod.removeRecipeAndEntity("destroyer-capsule","capsule")
factorioEducationalMod.removeRecipeAndEntity("discharge-defense-remote","capsule")
factorioEducationalMod.removeRecipeAndEntity("distractor-capsule","capsule")
-- Still used by military science pack, don't remove for now
--factorioEducationalMod.removeRecipeAndEntity("grenade","capsule")
factorioEducationalMod.removeRecipeAndEntity("poison-capsule","capsule")
factorioEducationalMod.removeRecipeAndEntity("slowdown-capsule","capsule")

-- Simple armors (with no equipment grid)

--factorioEducationalMod.removeRecipeAndEntity("heavy-armor","armor")
--factorioEducationalMod.removeRecipeAndEntity("light-armor","armor")

-- Defense Equipment

factorioEducationalMod.removeRecipeEntityAndItem("discharge-defense-equipment","active-defense-equipment")
factorioEducationalMod.removeRecipeEntityAndItem("personal-laser-defense-equipment","active-defense-equipment")

-- Turrets

-- Still used by military science pack, don't remove for now and unlock it from beginning
--factorioEducationalMod.removeRecipeEntityAndItem("gun-turret","ammo-turret")
data.raw["recipe"]["gun-turret"].enabled=true
factorioEducationalMod.removeRecipeEntityAndItem("laser-turret","electric-turret")
factorioEducationalMod.removeRecipeEntityAndItem("flamethrower-turret","fluid-turret")

-- Explosives

factorioEducationalMod.removeRecipeAndItem("explosives")
-- can be boosted by prod module, remove it from the list
factorioEducationalMod.removeItemFromProdModuleLimitation("explosives")

-- Tanks

factorioEducationalMod.removeRecipeAndEntity("tank","car")
data.raw["item-with-entity-data"].tank = nil

------ Technologies

---- Modifications

-- since no more heavy armor we need to link the modular armor to heavy armor prerequisite
factorioEducationalMod.removeTechnologyPrerequisite("modular-armor","heavy-armor")
factorioEducationalMod.addTechnologyPrerequisite("modular-armor",data.raw.technology["heavy-armor"].prerequisites)
factorioEducationalMod.removeTechnologyPrerequisite("modular-armor","military") --added when transfering heavy armor prerequisites
-- Remove explosives item from explosive tech
factorioEducationalMod.removeTechnologyRecipeUnlock("explosives","explosives")
-- Remove rocket launcher and ammo from rocketry
factorioEducationalMod.removeTechnologyRecipeUnlock("rocketry","rocket-launcher")
factorioEducationalMod.removeTechnologyRecipeUnlock("rocketry","rocket")
-- remove military prerequisite from rocketry
factorioEducationalMod.removeTechnologyPrerequisite("rocketry","military-2") --added when transfering heavy armor prerequisites
-- remove military prerequisite from gates
factorioEducationalMod.removeTechnologyPrerequisite("gates","military-2") --added when transfering heavy armor prerequisites

-- since military add the black science pack, we need to move that pack to another technology, advanced electronics for now until we know what to do.
factorioEducationalMod.addTechnologyRecipeUnlock("advanced-electronics","military-science-pack")

---- Deletions

factorioEducationalMod.removeTechnology("military") --don't have -1 at the end of its name
factorioEducationalMod.removeTechnologyIncrement("military-",2)
factorioEducationalMod.removeTechnology("turrets")
factorioEducationalMod.removeTechnology("heavy-armor")
factorioEducationalMod.removeTechnology("laser")
factorioEducationalMod.removeTechnology("flamethrower")
factorioEducationalMod.removeTechnology("land-mine")
factorioEducationalMod.removeTechnology("combat-robotics")
factorioEducationalMod.removeTechnologyIncrement("combat-robotics-",2)
factorioEducationalMod.removeTechnology("laser-turrets")
factorioEducationalMod.removeTechnology("tanks")
factorioEducationalMod.removeTechnology("explosive-rocketry")
factorioEducationalMod.removeTechnology("personal-laser-defense-equipment")
factorioEducationalMod.removeTechnology("discharge-defense-equipment")
factorioEducationalMod.removeTechnology("cluster-grenade")
factorioEducationalMod.removeTechnologyIncrement("bullet-speed-")
factorioEducationalMod.removeTechnologyIncrement("shotgun-shell-speed-")
factorioEducationalMod.removeTechnologyIncrement("laser-turret-speed-")
factorioEducationalMod.removeTechnologyIncrement("rocket-speed-",6) --five first level needed for silo
factorioEducationalMod.removeTechnology("uranium-ammo")
factorioEducationalMod.removeTechnologyIncrement("cannon-shell-speed-")
factorioEducationalMod.removeTechnology("atomic-bomb")
factorioEducationalMod.removeTechnologyIncrement("rocket-damage-")
factorioEducationalMod.removeTechnologyIncrement("cannon-shell-damage-")
factorioEducationalMod.removeTechnologyIncrement("bullet-damage-")
factorioEducationalMod.removeTechnologyIncrement("grenade-damage-")
factorioEducationalMod.removeTechnologyIncrement("shotgun-shell-damage-")
factorioEducationalMod.removeTechnologyIncrement("laser-turret-damage-")
factorioEducationalMod.removeTechnologyIncrement("gun-turret-damage-")
factorioEducationalMod.removeTechnologyIncrement("flamethrower-damage-")
factorioEducationalMod.removeTechnologyIncrement("combat-robot-damage-")
factorioEducationalMod.removeTechnologyIncrement("follower-robot-count-")


-- Remove achievement related to figthing or unobtainable

data.raw["dont-build-entity-achievement"]["raining-bullets"] = nil
data.raw["group-attack-achievement"]["it-stinks-and-they-dont-like-it"] = nil
data.raw["kill-achievement"]["pyromaniac"] = nil
data.raw["kill-achievement"]["steamrolled"] = nil
data.raw["combat-robot-count"]["minions"] = nil
